#include "StdAfx.h"
#include "GSGetFileUtil.h"

/* Defines */
#define GSGETFILE_DLLNAME	_T("gsgetfile.dll")
#define GSGETOPENFILENAME	_T("gsGetOpenFileName")
#define GSGETSAVEFILENAME	_T("gsGetSaveFileName")

/* Typedefs */
typedef BOOL (* PFNGETOPENFILENAME) (OPENFILENAME*);
typedef BOOL (* PFNGETSAVEFILENAME) (OPENFILENAME*);

///////////////////////////////////////////////////////////


BOOL
GetOpenFileNameEx(OPENFILENAME* pofn)
{
	BOOL				bRet = FALSE;
	HINSTANCE			hModule = NULL;
	PFNGETOPENFILENAME	pfnGetOpenFileName = NULL;

	bRet = FALSE;

	hModule =  LoadLibrary(GSGETFILE_DLLNAME);
	if (hModule != NULL) {
		pfnGetOpenFileName = (PFNGETOPENFILENAME)GetProcAddress(hModule, GSGETOPENFILENAME);
	}

	if (pfnGetOpenFileName != NULL) {
		bRet = (*pfnGetOpenFileName)(pofn);
	}
	else {
		bRet = GetOpenFileName(pofn);
	}

	if (hModule != NULL) {
		FreeLibrary(hModule);
		hModule = NULL;
		pfnGetOpenFileName = NULL;
	}

	return bRet;
}


BOOL
GetSaveFileNameEx(OPENFILENAME* pofn)
{
	BOOL				bRet = FALSE;
	HINSTANCE			hModule = NULL;
	PFNGETSAVEFILENAME	pfnGetSaveFileName = NULL;

	bRet = FALSE;

	hModule =  LoadLibrary(GSGETFILE_DLLNAME);
	if (hModule != NULL) {
		pfnGetSaveFileName = (PFNGETSAVEFILENAME)GetProcAddress(hModule, GSGETSAVEFILENAME);
	}

	if (pfnGetSaveFileName != NULL) {
		bRet = (*pfnGetSaveFileName)(pofn);
	}
	else {
		bRet = GetSaveFileName(pofn);
	}

	if (hModule != NULL) {
		FreeLibrary(hModule);
		hModule = NULL;
		pfnGetSaveFileName = NULL;
	}

	return bRet;
}