// WSIMFileGet.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include <commctrl.h>
#include <aygshell.h>
#include <commdlg.h>

#include "WSIMFileGet.h"
#include "FTUtil.h"
#include "GSGetFileUtil.h"


/* Defines */
#define MAX_LOADSTRING 100

/* Global Variables */
HINSTANCE			g_hInst;				// The current instance
HWND				g_hwndCB;				// The command bar handle
static SHACTIVATEINFO s_sai;

/* ProtoTypes */
LRESULT CALLBACK	DialogProc (HWND, UINT, WPARAM, LPARAM);


////////////////////////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	g_hInst = hInstance;
	DialogBox(hInstance, (LPCTSTR)IDD_WSIMFILEGET, NULL, (DLGPROC)DialogProc);
	return 0;
}

static
HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}

static
BOOL
GetFileList(
	HWND	hDlg
)
{
	int		iRet;
	HWND	hList = NULL;
	BOOL	bRet = FALSE;
	
	hList = GetDlgItem(hDlg, IDC_FILELIST);
	ListView_DeleteAllItems(hList);

	iRet = FTUtil_ProcessBegin();
	Sleep(100);

	if (iRet == 1) {
		struct WSIMFileList_TAG	fileList;

		memset(&fileList, 0, sizeof(fileList));

		// WSIMɕۑĂt@C̃Xg擾
		iRet = FTUtil_GetFileList(&fileList);
		Sleep(100);

		if (iRet == 0) {
			int		i;
			int		nListIdx;

			nListIdx = 0;
			for (i = 0; i < WSIM_MAX_FILE_NUM; i++) {
				TCHAR	szFileName[WSIM_MAX_FILENAME];
				TCHAR	szFileSize[64];


				// t@CANSI->UNICODE֕ϊ
				wsprintf(szFileName, _T("%S"), fileList.szFileNames[i]);

				// t@CTCY
				wsprintf(szFileSize, _T("%d"), fileList.ulFileSizes[i]);
				

				if (wcslen(szFileName) != 0) {
					LVITEM	item;

					memset(&item, 0, sizeof(item));
					item.mask = LVIF_TEXT|LVIF_PARAM;
					item.pszText = szFileName;
					item.iItem = nListIdx;
					item.iSubItem = 0;
					item.lParam = fileList.ulFileSizes[i];
					ListView_InsertItem(hList, &item);

					memset(&item, 0, sizeof(item));
					item.mask = LVIF_TEXT;
					item.pszText = szFileSize;
					item.iItem = nListIdx;
					item.iSubItem = 1;
					ListView_SetItem(hList, &item);
					nListIdx++;
				}
			}

			bRet = TRUE;
		}

		FTUtil_ProcessEnd();
	}

	return bRet;

}

static
BOOL
GetRecvFileInfo(
	HWND			hDlg,				// IN
	LPTSTR			pFileName,			// OUT	(CWSIM_MAX_FILENAMEȏ̃TCY͗pӂĂ)
	unsigned long*	pulFileSize			// OUT

)
{
	int		nItem;
	BOOL	bRet;
	HWND	hList = NULL;

	if (pFileName == NULL || pulFileSize == NULL) {
		return FALSE;
	}


	hList = GetDlgItem(hDlg, IDC_FILELIST);
	nItem = ListView_GetNextItem( hList, -1, LVNI_ALL | LVNI_SELECTED);
	if (nItem != -1) {
		LVITEM	item;

		// Xgt@CƃTCY擾
		memset(&item, 0, sizeof(item));
		item.mask = LVIF_TEXT|LVIF_PARAM;
		item.pszText = pFileName;
		item.cchTextMax = WSIM_MAX_FILENAME;
		item.iItem = nItem;
		item.iSubItem = 0;

		ListView_GetItem(hList, &item);

		*pulFileSize = item.lParam;

		bRet = TRUE;
	}

	return bRet;
}


static
BOOL
ReceiveFile(
	LPTSTR			pOutputFilePath,
	LPTSTR			pFileName,
	unsigned long	ulFileSize
)
{
	int		iRet;
	BOOL	bRet;

	bRet = FALSE;
	// WSIMւ̃ANZX̊Jn
	if (pOutputFilePath == NULL || pFileName == NULL) {
		return FALSE;
	}

	iRet = FTUtil_ProcessBegin();
	Sleep(100);

	if (iRet == 1) {
		// W-SIMt@C̎擾
		iRet = FTUtil_RecvFile(pOutputFilePath, pFileName, ulFileSize);

		// WSIMւ̃ANZX̏I
		FTUtil_ProcessEnd();

		bRet = TRUE;
	}

	return bRet;
}


// Mesage handler for the About box.
LRESULT CALLBACK DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				HWND		hList = NULL;
				LV_COLUMN	lvcol;
				DWORD		dwStyle;

				// RRg[̏
				INITCOMMONCONTROLSEX iCC;
				iCC.dwSize = sizeof(iCC);
				iCC.dwICC = ICC_LISTVIEW_CLASSES;

				InitCommonControlsEx(&iCC);

				// Create a Done button and size it.  
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;

				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);

				//
				CreateRpCommandBar(hDlg);

				//
				hList = GetDlgItem(hDlg, IDC_FILELIST);

				dwStyle = ListView_GetExtendedListViewStyle(hList);
				dwStyle |= LVS_EX_FULLROWSELECT;
				ListView_SetExtendedListViewStyle(hList, dwStyle);

				memset(&lvcol, 0, sizeof(lvcol));
				lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
				lvcol.fmt = LVCFMT_LEFT;
				lvcol.cx = 250;
				lvcol.pszText = L"t@C";
				lvcol.iSubItem = 0;

				ListView_InsertColumn(hList, 0, &lvcol);

				memset(&lvcol, 0, sizeof(lvcol));
				lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
				lvcol.fmt = LVCFMT_LEFT;
				lvcol.cx = 180;
				lvcol.pszText = L"TCY";
				lvcol.iSubItem = 1;

				ListView_InsertColumn(hList, 1, &lvcol);

				// WSIMANZXn֐̏
				FTUtil_Initialize();
			}
			return TRUE;
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDOK:
			case IDCANCEL:
			case IDM_MENU_CANCEL:
				{
					FTUtil_Terminate();		// WSIMANZXn֐̌n

					CommandBar_Destroy(g_hwndCB);
					EndDialog(hDlg, LOWORD(wParam));
				}
				return TRUE;
				break;

			case IDM_MENU_GETLIST:
				{
					BOOL	bListGet;

					bListGet = GetFileList(hDlg);
					if (!bListGet) {
						MessageBox(hDlg, _T("t@CXg̎擾Ɏs܂"), _T("WSIMFileGet"), MB_ICONINFORMATION|MB_OK);
					}
				}
				return TRUE;
				break;

			break;

		case IDC_GETLIST:
			{
				BOOL	bListGet;

				bListGet = GetFileList(hDlg);
				if (!bListGet) {
					MessageBox(hDlg, _T("t@CXg̎擾Ɏs܂"), _T("WSIMFileGet"), MB_ICONINFORMATION|MB_OK);
				}
			}
			return TRUE;
			break;

		case IDC_GETFILE:
			{
				TCHAR	szFileName[WSIM_MAX_FILENAME];
				TCHAR	szOutputFilePath[MAX_PATH + 1];
				unsigned long ulFileSize = 0;

				memset(szFileName, 0, sizeof(szFileName));
				if (GetRecvFileInfo(hDlg, szFileName, &ulFileSize)) {
					OPENFILENAME	ofn;

					_tcscpy(szOutputFilePath, szFileName);

					memset(&ofn, 0, sizeof(ofn));
					ofn.lStructSize = sizeof(ofn);
					ofn.hwndOwner = hDlg;
					ofn.lpstrFile = szOutputFilePath;
					ofn.nMaxFile = sizeof(szOutputFilePath)/sizeof(szOutputFilePath[0]);
					ofn.lpstrTitle = L"̧ق̕ۑ...";
					ofn.lpstrFilter = L"SĂ̧ (*.*)\0*.*\0\0";
					ofn.Flags = OFN_OVERWRITEPROMPT;

					if (GetSaveFileNameEx(&ofn)) {
						if (ReceiveFile(szOutputFilePath, szFileName, ulFileSize)) {
							MessageBox(hDlg, _T("擾"), _T("WSIMFileGet"), MB_ICONINFORMATION|MB_OK);
						}
						else {
							MessageBox(hDlg, _T("擾Ɏs܂B"), _T("WSIMFileGet"), MB_ICONINFORMATION|MB_OK);
						}
					}
				}

			}
			return TRUE;
			break;
		}

	}
    return FALSE;
}
